# Create

Create a new Virtual Cluster.

Valid virtual cluster types: `byoc`, `byoc_data_lake` (tableflow) or `byoc_schema_registry`.

By default, this API endpoint creates a virtual cluster as well as an agent key for it, which is included in the response. Pass `"skip_agent_key_creation": true` to avoid creating the agent key, in which case `agent_key` is `null` in the response. For example, the official WarpStream Terraform provider sets this field to `true`.

To create the agent key in the [v2 key format](/warpstream/reference/api-reference/api-keys#key-formats), use [Create (v2)](/warpstream/reference/api-reference/virtual-clusters/create-v2).

## Request

```bash wrap
curl https://api.warpstream.com/api/v1/create_virtual_cluster \
-H 'warpstream-api-key: XXXXXXXXXX' \
-H 'Content-Type: application/json' \
-d '{"virtual_cluster_name": "XXXXXXXXXX", "virtual_cluster_type": "byoc", "virtual_cluster_region": "us-east-1", "virtual_cluster_cloud_provider": "aws", "virtual_cluster_tier": "dev"}'
```

## Response

```json
{
    "virtual_cluster_id": "vci_1d4930d7_8e6d_4ad9_b27a_654ed4aaa3ee",
    "virtual_cluster_name": "XXXXXXXXXX",
    "agent_pool_id": "api_417d3bf3_026d_4261_bb16_fe59a4262757",
    "agent_pool_name": "apn_XXXXXXXXXX",
    "agent_key": {
        "id":"aki_007f0341_3ab3_457a_a513_2b2c9415582f",
        "name": "akn_virtual_cluster_XXXXXXXXX_44c7ee374113",
        "key":"aks_a51b1fb20ac4a3af549503bb08cd309672fcada1030c5a494850e87ce5d4c613",
        "created_at":"2024-05-02T18:54:48.990229Z",
        "access_grants": [{
            "principal_kind": "agent",
            "resource_kind":"virtual_cluster",
            "resource_id":"vci_1d4930d7_8e6d_4ad9_b27a_654ed4aaa3ee"
        }]
    },
    "bootstrap_url": "api-417d3bf3-026d-4261-bb16-fe59a4262757.kafka.discoveryv2.prod-z.us-east-1.warpstream.com:9092"
}
```